> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://devin.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://devin.ferndocs.com/_mcp/server.

# Bulk index repositories

PUT https://api.devin.ai/v3beta1/organizations/{org_id}/repositories/indexing
Content-Type: application/json

Idempotently enables indexing for a batch of repositories and triggers indexing jobs.

Reference: https://devin.ferndocs.com/api-reference/v-3/bulk-index-repositories

## Authentication

- `Authorization` header (bearer token, required) — Personal API Key (apk_user_*) or Service API Key (apk_*)

## Request

### Path parameters

- `org_id` (string, required)

### Body (application/json)

This endpoint expects a BulkIndexRepositoriesRequest.

- `repositories` (list of RepositoryIndexingItem, required)

## Response

### 200

Successful Response

- `list of RepositoryIndexingResponse`

## Errors

### 422 Unprocessable Entity Error

Validation Error

- `detail` (list of ValidationError, optional)

## Types

### RepositoryIndexingItem

- `repository_path` (string, required) — e.g., 'org/repo-name'
- `branch_names` (list of string, optional)

### RepositoryIndexingResponse

- `branches` (list of string, required)
- `indexing_enabled` (boolean, required)
- `repository_path` (string, required)
- `indexing_status` (RepoIndexingStatusResponse, optional, nullable)

### ValidationError

- `loc` (list of ValidationErrorLocItems, required)
- `msg` (string, required)
- `type` (string, required)

### RepoIndexingStatusResponse

- `indexing_enabled` (boolean, required)
- `latest_completed_search_index_job` (RepoIndexJobResponse, required, nullable)
- `latest_completed_wiki_index_job` (RepoIndexJobResponse, required, nullable)
- `latest_indexes` (list of RepoIndexJobResponse, required)

### ValidationErrorLocItems

### RepoIndexJobResponse

- `branch_name` (string, required, nullable)
- `commit` (string, required)
- `created_at` (integer, required)
- `job_id` (string, required)
- `status` (enum, required)
  - Allowed values: `failed`, `completed`, `in_progress`

## Examples

**Request**

```json
{
  "repositories": [
    {
      "repository_path": "acme-corp/payment-service"
    }
  ]
}
```

**Response**

```json
[
  {
    "branches": [
      "main",
      "develop",
      "release"
    ],
    "indexing_enabled": true,
    "repository_path": "acme-corp/payment-service",
    "indexing_status": {
      "indexing_enabled": true,
      "latest_completed_search_index_job": {
        "branch_name": "main",
        "commit": "a1b2c3d4e5f6g7h8i9j0",
        "created_at": 1685606400,
        "job_id": "job-12345",
        "status": "completed"
      },
      "latest_completed_wiki_index_job": {
        "branch_name": "main",
        "commit": "f1e2d3c4b5a697887766",
        "created_at": 1685520000,
        "job_id": "job-12344",
        "status": "completed"
      },
      "latest_indexes": [
        {
          "branch_name": "develop",
          "commit": "b2c3d4e5f6g7h8i9j0a1",
          "created_at": 1685481600,
          "job_id": "job-12343",
          "status": "completed"
        }
      ]
    }
  }
]
```

**SDK Code**

```python
import requests

url = "https://api.devin.ai/v3beta1/organizations/org_id/repositories/indexing"

payload = { "repositories": [{ "repository_path": "acme-corp/payment-service" }] }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.devin.ai/v3beta1/organizations/org_id/repositories/indexing';
const options = {
  method: 'PUT',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"repositories":[{"repository_path":"acme-corp/payment-service"}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.devin.ai/v3beta1/organizations/org_id/repositories/indexing"

	payload := strings.NewReader("{\n  \"repositories\": [\n    {\n      \"repository_path\": \"acme-corp/payment-service\"\n    }\n  ]\n}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.devin.ai/v3beta1/organizations/org_id/repositories/indexing")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"repositories\": [\n    {\n      \"repository_path\": \"acme-corp/payment-service\"\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://api.devin.ai/v3beta1/organizations/org_id/repositories/indexing")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"repositories\": [\n    {\n      \"repository_path\": \"acme-corp/payment-service\"\n    }\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://api.devin.ai/v3beta1/organizations/org_id/repositories/indexing', [
  'body' => '{
  "repositories": [
    {
      "repository_path": "acme-corp/payment-service"
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.devin.ai/v3beta1/organizations/org_id/repositories/indexing");
var request = new RestRequest(Method.PUT);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"repositories\": [\n    {\n      \"repository_path\": \"acme-corp/payment-service\"\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["repositories": [["repository_path": "acme-corp/payment-service"]]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.devin.ai/v3beta1/organizations/org_id/repositories/indexing")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```